package global;

public class GlobalData {

	//TODO ver que variables hacen falta

	public static String Metadatos [] = {"Variable", "AditividadTemporal", "AditividadEspacial", "Frecuencia", "Fecha", "Unidades", "Nivel", "TipoDato", "NaturalezaDato", "OrigenDatos"};
	public static final int NUMMETADATOS = Metadatos.length;
	
	//campos para los ficheros XML de datos
	public static String Campo [] = {"Variable", "AditividadTemporal", "AditividadEspacial", "Frecuencia", "Fecha", "Unidades", "Lugar", "Nivel", "TipoDato", "NaturalezaDato", "Valor", "OrigenDatos"};
	public enum CampoEnum {Variable, AditividadTemporal, AditividadEspacial, Frecuencia, Fecha, Unidades, Lugar, Nivel, TipoDato, NaturalezaDato, Valor, OrigenDatos}
	
	public static String JerarquiaRegiones [] = {"Municipio", "Provincia", "Autonomia", "Pais"};
		
	public static String InfoVariable [] = {"NombreVariable", "AditividadTemporal", "AditividadEspacial", "Frecuencia", "Unidades", "TipoDato", "NaturalezaDato", "OrigenDatos"};
	public static final int NUM_ATRIBS_VARIABLES_SIN_ID = InfoVariable.length;
	
	public static int NUMCOLS = 10;
	public static int NUMFILAS = 100;

	public static String bd = "goodwave";
	public static String login = "root";
	public static String password = "admin";
	public static String url = "jdbc:mysql://localhost/"+bd;
	public static String connectionURL = "jdbc:mysql://localhost/goodwave?user=root&password=admin&connectionCollation=latin1_spanish_ci";
	
	/**
	 * Devuelve la posicion en el vector <i>Campo</i> de <i>str</i>
	 * @param str Nombre del campo a buscar en <i>Campo</i>
	 * @return entero con la posicion de <i>str</i>
	 * */
	public static int indexOfCampo(String str){
		
		for (int i=0; i<Campo.length ; i++){
			if (str.compareToIgnoreCase(Campo[i]) == 0){
				return i;
			}
		}
		
		return -1;
	}
	
	/**
	 * Devuelve la posicion en el vector <i>Metadatos</i> de <i>str</i>
	 * @param str Nombre del metadato a buscar en <i>Metadatos</i>
	 * @return entero con la posicion de <i>str</i>
	 * */
	public static int indexOfMetadato(String str){
		
		for (int i=0; i<Metadatos.length ; i++){
			if (str.compareToIgnoreCase(Metadatos[i]) == 0){
				return i;
			}
		}
		
		return -1;
	}
	
	/**
	 * Devuelve la posicion en el vector <i>JerarquiaRegiones</i> de <i>str</i>
	 * @param str Nombre del nivel de jerarquia a buscar en <i>JerarquiaRegiones</i>
	 * @return entero con la posicion de <i>str</i>
	 * */
	public static int indexOfJerarquiaRegiones(String str){
		
		for (int i=0; i<JerarquiaRegiones.length ; i++){
			if (str.compareToIgnoreCase(JerarquiaRegiones[i]) == 0){
				return i;
			}
		}
		
		return -1;
	}
	
	/**
	 * Devuelve la posicion en el vector <i>InfoVariable</i> de <i>str</i>
	 * @param str Nombre de campo de la variable a buscar en <i>InfoVariable</i>
	 * @return entero con la posicion de <i>str</i>
	 * */
	public static int indexOfInfoVariable(String str){
		
		for (int i=0; i<InfoVariable.length ; i++){
			if (str.compareToIgnoreCase(InfoVariable[i]) == 0){
				return i;
			}
		}
		
		return -1;
	}

	/**
	 * Devuelve el primer valor del vector <i>Campo</i>
	 * @return objeto CampoEnum con el valor de la primera componente del vector <i>Campo</i>
	 * */
	public static CampoEnum PrimerValorCampoEnum() {
		return CampoEnum.Variable;
	}
	
	/**
	 * Devuelve el siguiente valor a <i>campo2</i> del vector <i>Campo</i>
	 * @return objeto CampoEnum con el valor de la siguiente componente a <i>campo2</i> del vector <i>Campo</i>
	 * */
	public static CampoEnum incrementarCampoEnum(CampoEnum campo2) {
		
		switch (campo2){
			case Variable:
				campo2 = CampoEnum.AditividadTemporal;
				break;
			case AditividadTemporal:
				campo2 = CampoEnum.AditividadEspacial;
				break;
			case AditividadEspacial:
				campo2 = CampoEnum.Frecuencia;
				break;
			case Frecuencia:
				campo2 = CampoEnum.Fecha;
				break;
			case Fecha:
				campo2 = CampoEnum.Unidades;
				break;
			case Unidades:
				campo2 = CampoEnum.Lugar;
				break;
			case Lugar:
				campo2 = CampoEnum.Nivel;
				break;
			case Nivel:
				campo2 = CampoEnum.TipoDato;
				break;
			case TipoDato:
				campo2 = CampoEnum.NaturalezaDato;
				break;
			case NaturalezaDato:
				campo2 = CampoEnum.Valor;
				break;
			case Valor:
				campo2 = CampoEnum.OrigenDatos;
				break;
			case OrigenDatos:
			default:
				campo2 = null;
		}
		return campo2;
	}
	
	/**
	 * Devuelve el valor a <i>CampoEnum</i> que indica <i>nivel</i>
	 * @param nivel <b>String</b> con el nombre del campo que se quiere conseguir
	 * @return objeto CampoEnum con el valor del campo indicado por <i>nivel</i>
	 * */
	public static CampoEnum setCampoEnum(String nivel) {
			
		if (nivel.compareToIgnoreCase("Variable") == 0)
			return CampoEnum.Variable;
		else if (nivel.compareToIgnoreCase("AditividadTemporal") == 0)
			return CampoEnum.AditividadTemporal;
		else if (nivel.compareToIgnoreCase("AditividadEspacial") == 0)
			return CampoEnum.AditividadEspacial;
		else if (nivel.compareToIgnoreCase("Frecuencia") == 0)
			return CampoEnum.Frecuencia;
		else if (nivel.compareToIgnoreCase("Fecha") == 0)
			return CampoEnum.Fecha;
		else if (nivel.compareToIgnoreCase("Unidades") == 0)
			return CampoEnum.Unidades;
		else if (nivel.compareToIgnoreCase("Lugar") == 0)
			return CampoEnum.Lugar;
		else if (nivel.compareToIgnoreCase("Nivel") == 0)
			return CampoEnum.Nivel;
		else if (nivel.compareToIgnoreCase("TipoDato") == 0)
			return CampoEnum.TipoDato;
		else if (nivel.compareToIgnoreCase("NaturalezaDato") == 0)
			return CampoEnum.NaturalezaDato;
		else if (nivel.compareToIgnoreCase("Valor") == 0)
			return CampoEnum.Valor;
		else if (nivel.compareToIgnoreCase("OrigenDatos") == 0)
			return CampoEnum.OrigenDatos;
		else return null;
	}
	
	/**
	 * Devuelve el siguiente valor a <i>nivel</i> del vector <i>JerarquiaRegiones</i>
	 * @return objeto <b>String</b> con el valor de la siguiente componente a <i>nivel</i> del vector <i>JerarquiaRegiones</i>
	 * */
	public static String incrementarJerarquiaRegiones(String nivel) {
		
		if (nivel.compareToIgnoreCase("Pais") == 0)
			return null;
		else if (nivel.compareToIgnoreCase("Autonomia") == 0)
			return "Pais";
		else if (nivel.compareToIgnoreCase("Provincia") == 0)
			return "Autonomia";
		else if (nivel.compareToIgnoreCase("Municipio") == 0)
			return "Provincia";
		else return null;
	}
}
